## git-repair 1.20140115

=== Makefile ===
PREFIX=/usr
CABAL?=cabal # set to "./Setup" if you lack a cabal program

build: Build/SysConfig.hs
	$(CABAL) build
	ln -sf dist/build/git-repair/git-repair git-repair
	@$(MAKE) tags >/dev/null 2>&1 &

Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
	$(CABAL) configure

install: build
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-repair $(DESTDIR)$(PREFIX)/bin
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 git-repair.1 $(DESTDIR)$(PREFIX)/share/man/man1

clean:
	rm -rf git-repair git-repair-test.log \
		dist configure Build/SysConfig.hs Setup tags
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

# Upload to hackage.
hackage: clean
	./Build/make-sdist.sh
	@cabal upload dist/*.tar.gz

# hothasktags chokes on some template haskell etc, so ignore errors
tags:
	find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$' | xargs hothasktags > tags 2>/dev/null

.PHONY: tags

## git-repair 1.20131122

=== debian/changelog ===
git-repair (1.20131122) unstable; urgency=low

  * Added test mode, which can be used to randomly corrupt test 
    repositories, in reproducible ways, which allows easy
    corruption-driven-development.
  * Improve repair code in the case where the index file is corrupt,
    and this hides other problems.
  * Write a dummy .git/HEAD if the file is missing or corrupt, as
    git otherwise will not treat the repository as a git repo.
  * Improve fsck code to find badly corrupted objects that crash git fsck
    before it can complain about them.
  * Fixed crashes on bad file encodings.
  * Can now run 10000 tests (git-repair --test -n 10000 --force)
    with 0 failures.

 -- Joey Hess <joeyh@debian.org>  Fri, 22 Nov 2013 11:16:03 -0400

git-repair (1.20131118) unstable; urgency=low

  * First release

 -- Joey Hess <joeyh@debian.org>  Mon, 18 Nov 2013 13:38:12 -0400

=== debian/control ===
Source: git-repair
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc,
	git,
	libghc-missingh-dev,
	libghc-hslogger-dev,
	libghc-network-dev,
	libghc-ifelse-dev,
	libghc-extensible-exceptions-dev,
	libghc-unix-compat-dev,
	libghc-utf8-string-dev,
	libghc-async-dev,
	libghc-optparse-applicative-dev
Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.9.4
Vcs-Git: git://git-repair.branchable.com/
Homepage: http://git-repair.branchable.com/

Package: git-repair
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}, git, rsync
Description: repair various forms of damage to git repositorie
 git-repair can repair various forms of damage to git repositories.
 .
 It is a complement to git fsck, which finds problems, but does not fix them.

## git-repair 1.20131203

=== debian/changelog ===
git-repair (1.20131203) unstable; urgency=low

  * Fix build deps. Closes: #731179

 -- Joey Hess <joeyh@debian.org>  Tue, 03 Dec 2013 15:02:21 -0400

## git-repair 1.20131213

=== debian/changelog ===
git-repair (1.20131213) unstable; urgency=low

  * Improve repair of index files in some situations.

 -- Joey Hess <joeyh@debian.org>  Fri, 13 Dec 2013 14:51:51 -0400

## git-repair 1.20140115

=== debian/changelog ===
git-repair (1.20140115) unstable; urgency=medium

  * Support old git versions from before git fsck --no-dangling was
    implemented.
  * Fix bug in packed refs file exploding code that caused a .gitrefs
    directory to be created instead of .git/refs

 -- Joey Hess <joeyh@debian.org>  Wed, 15 Jan 2014 16:53:30 -0400

=== debian/control ===
--- 
+++ 
@@ -8,9 +8,11 @@
 	libghc-missingh-dev,
 	libghc-hslogger-dev,
 	libghc-network-dev,
-	libghc-ifelse-dev,
 	libghc-extensible-exceptions-dev,
 	libghc-unix-compat-dev,
+	libghc-ifelse-dev,
+	libghc-text-dev,
+	libghc-quickcheck2-dev,
 	libghc-utf8-string-dev,
 	libghc-async-dev,
 	libghc-optparse-applicative-dev
@@ -27,3 +29,7 @@
  git-repair can repair various forms of damage to git repositories.
  .
  It is a complement to git fsck, which finds problems, but does not fix them.
+ .
+ As well as avoiding the need to rm -rf a damaged repository and re-clone,
+ using git-repair can help rescue commits you've made to the damaged
+ repository and not yet pushed out.

## git-repair 1.20140423

=== debian/changelog ===
git-repair (1.20140423) unstable; urgency=medium

  * Improve memory usage when git fsck finds a great many broken objects.
  * Merge from git-annex.

 -- Joey Hess <joeyh@debian.org>  Wed, 23 Apr 2014 14:01:30 -0400

git-repair (1.20140227) unstable; urgency=medium

  * Optimise unpacking of pack files, and avoid repeated error
    messages about corrupt pack files.
  * Add swapping 2 files test case.

 -- Joey Hess <joeyh@debian.org>  Thu, 27 Feb 2014 11:56:27 -0400

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	libghc-async-dev,
 	libghc-optparse-applicative-dev
 Maintainer: Joey Hess <joeyh@debian.org>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Git: git://git-repair.branchable.com/
 Homepage: http://git-repair.branchable.com/

## git-repair 1.20140914

=== Makefile ===
--- 
+++ 
@@ -29,6 +29,6 @@
 
 # hothasktags chokes on some template haskell etc, so ignore errors
 tags:
-	find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$' | xargs hothasktags > tags 2>/dev/null
+	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -c --cpp -c -traditional -c --include=dist/build/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags
 
 .PHONY: tags

=== debian/changelog ===
git-repair (1.20140914) unstable; urgency=medium

  * Update to build with optparse-applicative 0.10. Closes: #761552

 -- Joey Hess <joeyh@debian.org>  Sun, 14 Sep 2014 12:48:27 -0400

git-repair (1.20140815) unstable; urgency=medium

  * Removing bad objects could leave fsck finding no more unreachable objects,
    but some branches no longer accessible. Fix this, including support for
    fixing up repositories that were incompletely repaired before.
  * Merge from git-annex.

 -- Joey Hess <joeyh@debian.org>  Fri, 15 Aug 2014 13:49:09 -0400

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 	libghc-quickcheck2-dev,
 	libghc-utf8-string-dev,
 	libghc-async-dev,
-	libghc-optparse-applicative-dev
+	libghc-optparse-applicative-dev (>= 0.10.0)
 Maintainer: Joey Hess <joeyh@debian.org>
 Standards-Version: 3.9.5
 Vcs-Git: git://git-repair.branchable.com/

## git-repair 1.20141027

=== debian/changelog ===
git-repair (1.20141027) unstable; urgency=medium

  * Adjust cabal file to support network-uri split.
  * Merge Build/ from git-annex, including removing a use of deprecated
    System.Cmd.

 -- Joey Hess <joeyh@debian.org>  Mon, 27 Oct 2014 11:09:56 -0400

git-repair (1.20141026) unstable; urgency=medium

  * Prevent auto gc from happening when fetching from a remote.
  * Merge from git-annex.

 -- Joey Hess <joeyh@debian.org>  Sun, 26 Oct 2014 13:37:30 -0400

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,8 @@
 	libghc-missingh-dev,
 	libghc-hslogger-dev,
 	libghc-network-dev,
-	libghc-extensible-exceptions-dev,
+	libghc-exceptions-dev (>= 0.6),
+	libghc-transformers-dev,
 	libghc-unix-compat-dev,
 	libghc-ifelse-dev,
 	libghc-text-dev,

## git-repair 1.20150106

=== debian/changelog ===
git-repair (1.20150106-2) unstable; urgency=medium

  * Fix typo in description

 -- Richard Hartmann <richih@debian.org>  Thu, 20 Aug 2015 13:41:50 +0200

git-repair (1.20150106-1) unstable; urgency=medium

  * Package 1.20150106
  * Update dependencies (Closes: #789977)
  * Take over maintenance of package
  * Bump standards version to 3.9.6

 -- Richard Hartmann <richih@debian.org>  Thu, 20 Aug 2015 11:24:46 +0200

git-repair (1.20150106) unstable; urgency=medium

  * Debian package is now maintained by Gergely Nagy.
  * Fix build with process 1.2.1.0.
  * Merge from git-annex.

 -- Joey Hess <id@joeyh.name>  Tue, 06 Jan 2015 19:09:23 -0400

## git-repair 1.20151215

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
 	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
-	$(CABAL) configure
+	$(CABAL) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"
 
 install: build
 	install -d $(DESTDIR)$(PREFIX)/bin

=== debian/changelog ===
git-repair (1.20151215-2) unstable; urgency=medium

  * Adopt package.
    Maintainer has approved this via personal communication.
  * Point Vcs-* fields at my repo.
  * Use https in Homepage: field & Format: field in d/copyright.
  * Declare compliance with Debian Policy 4.4.1.
  * Drop debian/gbp.conf.
  * Declare Rules-Requires-Root: no.
  * d/copyright:
    - Point Source: field at upstream git repo
    - Fix upstream copyright years to include 2014 & 2015
    - Replace `License: GPL-3+` body with standard text for this license.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 01 Jan 2020 21:38:27 +0000

git-repair (1.20151215-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch duplicate Arbitrary instance of EpochTime out of
    Utility/QuickCheck.hs (Closes: #897509).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 22 Jul 2018 14:33:24 +0800

git-repair (1.20151215-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Cherry pick upstream commit to add MIN_VERSION preprocessor guards to
    some instances defined in Utility.QuickCheck (Closes: #826389).
  * Cherry pick upstream commit to avoid duplicate import errors in
    Utility.Directory.
  * Patch Common.hs to avoid duplicate import errors.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 25 Jul 2017 17:27:22 -0700

git-repair (1.20151215-1) unstable; urgency=medium

  * Package 1.20151215-1

 -- Richard Hartmann <richih@debian.org>  Wed, 16 Dec 2015 07:26:04 +0100

git-repair (1.20151215) unstable; urgency=medium

  * Fix insecure temporary permissions and potential denial of
    service attack when creating temp dirs. Closes: #807341
  * Merge from git-annex.

 -- Joey Hess <id@joeyh.name>  Tue, 15 Dec 2015 20:47:59 -0400

=== debian/control ===
--- 
+++ 
@@ -16,17 +16,20 @@
 	libghc-quickcheck2-dev,
 	libghc-utf8-string-dev,
 	libghc-async-dev,
-	libghc-optparse-applicative-dev (>= 0.10.0)
-Maintainer: Joey Hess <joeyh@debian.org>
-Standards-Version: 3.9.5
-Vcs-Git: git://git-repair.branchable.com/
-Homepage: http://git-repair.branchable.com/
+	libghc-optparse-applicative-dev (>= 0.10.0),
+	libghc-network-uri-dev
+Maintainer: Sean Whitton <spwhitton@spwhitton.name>
+Standards-Version: 4.4.1
+Vcs-Git: https://git.spwhitton.name/git-repair
+Vcs-Browser: https://git.spwhitton.name/git-repair
+Homepage: https://git-repair.branchable.com/
+Rules-Requires-Root: no
 
 Package: git-repair
 Architecture: any
 Section: utils
 Depends: ${misc:Depends}, ${shlibs:Depends}, git, rsync
-Description: repair various forms of damage to git repositorie
+Description: repair various forms of damage to git repositories
  git-repair can repair various forms of damage to git repositories.
  .
  It is a complement to git fsck, which finds problems, but does not fix them.

## git-repair 1.20200102

=== Makefile ===
# set to "./Setup" if you lack a cabal program. Or can be set to "stack"
BUILDER?=cabal
GHC?=ghc

PREFIX=/usr

build: Build/SysConfig.hs
	$(BUILDER) build $(BUILDEROPTIONS)
	if [ "$(BUILDER)" = stack ]; then \
		ln -sf $$(stack path --dist-dir)/build/git-annex/git-repair git-repair; \
	else \
		ln -sf dist/build/git-repair/git-repair git-repair; \
	fi
	@$(MAKE) tags >/dev/null 2>&1 &

Build/SysConfig.hs: Build/TestConfig.hs Build/Configure.hs
	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
	if [ "$(BUILDER)" = stack ]; then \
		$(BUILDER) build $(BUILDEROPTIONS); \
	else \
		$(BUILDER) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
	fi

install: build
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-repair $(DESTDIR)$(PREFIX)/bin
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 git-repair.1 $(DESTDIR)$(PREFIX)/share/man/man1

clean:
	rm -rf git-repair git-repair-test.log \
		dist configure Build/SysConfig.hs Setup tags
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

# hothasktags chokes on some template haskell etc, so ignore errors
tags:
	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -c --cpp -c -traditional -c --include=dist/build/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags

.PHONY: tags

=== debian/changelog ===
git-repair (1.20200102-2build3) lunar; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 11 Dec 2022 13:55:18 +0100

git-repair (1.20200102-2build2) kinetic; urgency=medium

  * Rebuild against sane versioning.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Aug 2022 17:48:00 +0200

git-repair (1.20200102-2build1.1) impish; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Sep 2021 06:52:36 +0200

git-repair (1.20200102-2build1) groovy; urgency=medium

  * No-change rebuild against libffi8ubuntu1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Aug 2020 00:04:16 +0000

git-repair (1.20200102-2) unstable; urgency=medium

  * Patch Utility/HumanTime.hs to update type constraint Monad -> MonadFail
    (Closes: #964041).
  * Source package configuration for dgit-maint-merge(7):
    - Add d/source/options
    - Add d/source/patch-header.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 15 Jul 2020 13:46:18 -0700

git-repair (1.20200102-1) unstable; urgency=medium

  * New upstream release.
    - Tighten build-dep on optparse-applicative
    - Add build-deps on split, filepath-bytestring, attoparsec, data-default
    - Drop build-dep on missingh.
  * Drop all patches.
    Either merged upstream or obsoleted by upstream changes.
  * d/copyright updates:
    - Main project license is now AGPL-3+
    - Add stanza for Utility/Attoparsec.hs
    - Update copyright years.
  * Stop adding upstream entries to debian/changelog.
  * wrap-and-sort -abst

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 02 Jan 2020 19:07:12 +0000

=== debian/control ===
Source: git-repair
Section: utils
Priority: optional
Build-Depends:
 debhelper (>= 9),
 ghc,
 git,
 libghc-async-dev,
 libghc-attoparsec-dev,
 libghc-data-default-dev,
 libghc-exceptions-dev (>= 0.6),
 libghc-filepath-bytestring-dev (>= 1.4.2.1.0),
 libghc-hslogger-dev,
 libghc-ifelse-dev,
 libghc-network-dev,
 libghc-network-uri-dev,
 libghc-optparse-applicative-dev (>= 0.14.1),
 libghc-quickcheck2-dev,
 libghc-split-dev,
 libghc-text-dev,
 libghc-transformers-dev,
 libghc-unix-compat-dev,
 libghc-utf8-string-dev,
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sean Whitton <spwhitton@spwhitton.name>
Standards-Version: 4.4.1
Vcs-Git: https://git.spwhitton.name/git-repair
Vcs-Browser: https://git.spwhitton.name/git-repair
Homepage: https://git-repair.branchable.com/
Rules-Requires-Root: no

Package: git-repair
Architecture: any
Section: utils
Depends:
 git,
 rsync,
 ${misc:Depends},
 ${shlibs:Depends},
Description: repair various forms of damage to git repositories
 git-repair can repair various forms of damage to git repositories.
 .
 It is a complement to git fsck, which finds problems, but does not fix them.
 .
 As well as avoiding the need to rm -rf a damaged repository and re-clone,
 using git-repair can help rescue commits you've made to the damaged
 repository and not yet pushed out.

## git-repair 1.20230814

=== Makefile ===
# set to "./Setup" if you lack a cabal program. Or can be set to "stack"
BUILDER?=cabal
GHC?=ghc

PREFIX=/usr

build: Build/SysConfig.hs
	$(BUILDER) build $(BUILDEROPTIONS)
	if [ "$(BUILDER)" = stack ]; then \
		ln -sf $$(stack path --dist-dir)/build/git-repair/git-repair git-repair; \
	else \
		if [ -d dist-newstyle ]; then \
			ln -sf $$(cabal exec -- sh -c 'command -v git-repair') git-repair; \
		else \
			ln -sf dist/build/git-repair/git-repair git-repair; \
		fi; \
	fi
	@$(MAKE) tags

Build/SysConfig.hs: Build/TestConfig.hs Build/Configure.hs
	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
	if [ "$(BUILDER)" = stack ]; then \
		$(BUILDER) build $(BUILDEROPTIONS); \
	else \
		$(BUILDER) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
	fi

install: build
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-repair $(DESTDIR)$(PREFIX)/bin
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 git-repair.1 $(DESTDIR)$(PREFIX)/share/man/man1

clean:
	rm -rf git-repair git-repair-test.log \
		dist dist-newstyle configure Build/SysConfig.hs Setup tags
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

tags:
	hasktags . -c || true

.PHONY: tags

=== debian/changelog ===
git-repair (1.20230814-1build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 20 Jan 2026 20:41:07 +0000

git-repair (1.20230814-1) unstable; urgency=medium

  * New upstream release (Closes: #1054816).

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 19 Mar 2024 19:48:32 +0800
